=== platform/wasm/Makefile ===
default:
	bash build.sh
