=== debian/control ===
--- 
+++ 
@@ -1,13 +1,25 @@
 Source: mupdf
 Section: text
 Priority: optional
-Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Uploaders: Quoc-Viet Nguyen <afelion@gmail.com>
-Build-Depends: debhelper (>= 7.4.10~), dpkg-dev (>= 1.16.1.1~),
- libfreetype6-dev, pkg-config, libjpeg-dev, libjbig2dec-dev,
- libopenjp2-7-dev, libx11-dev, libxext-dev, zlib1g-dev,
- libharfbuzz-dev, freeglut3-dev, libssl-dev,
- python:any
+Build-Depends: debhelper (>= 12~),
+               dh-exec,
+               dpkg-dev (>= 1.16.1.1~),
+               freeglut3-dev,
+               libfreetype6-dev,
+               libharfbuzz-dev,
+               libjbig2dec-dev,
+               libjpeg-dev,
+               liblcms2-dev,
+               libopenjp2-7-dev,
+               libx11-dev,
+               libxext-dev,
+               pkg-config,
+               python:any,
+               zlib1g-dev
+Build-Conflicts: libssl-dev
 Standards-Version: 4.3.0
 Homepage: http://mupdf.com/
 Vcs-Git: https://salsa.debian.org/koster/mupdf.git
@@ -25,7 +37,7 @@
 
 Package: mupdf
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Suggests: mupdf-tools
 Provides: pdf-viewer
 Description: lightweight PDF viewer
@@ -39,7 +51,7 @@
 
 Package: mupdf-tools
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: command line tools for the MuPDF viewer
  MuPDF is a lightweight PDF viewer and toolkit written in portable C.
  It also reads XPS, OpenXPS and ePub documents.
