=== debian/rules ===
--- 
+++ 
@@ -63,5 +63,8 @@
 	-rm -rf generated
 	-rm -rf source/pdf/cmaps
 
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
+
 %:
-	dh $@ --parallel
+	dh $@
