=== debian/changelog ===
mupdf (1.17.0+ds1-2+deb11u1) bullseye-security; urgency=high

  * Non-maintainer upload by the Debian LTS team.
  * CVE-2020-21896: Prevent an issue where a use after free vulnerability could
    have allowed remote attackers to cause a denial of service via opening of a
    specially-crafted PDF file.

 -- Chris Lamb <lamby@debian.org>  Wed, 20 Aug 2025 10:36:56 -0700

mupdf (1.17.0+ds1-2) unstable; urgency=medium

  * Fix buffer overrun in tiff decoder (CVE-2020-19609) (Closes: #991401)
  * Stay within hash table max key size in cached color converter
    (CVE-2021-37220) (Closes: #991402)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Fri, 23 Jul 2021 17:09:37 +0900

mupdf (1.17.0+ds1-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix double free of object during linearization (CVE-2021-3407)
    (Closes: #983684)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 28 Feb 2021 13:40:40 +0100

mupdf (1.17.0+ds1-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix installation location of pkgconfig file.
    The libmupdf-dev.install file was not marked executable and thus could
    not correclty use dh-exec to substitute ${DEB_HOST_MULTIARCH} for the
    target path. (Closes: #976022)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 28 Nov 2020 14:59:08 +0100

mupdf (1.17.0+ds1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Detect/avoid overflow when calculating sizes of pixmaps (CVE-2020-26519)
    (Closes: #971595)

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 03 Nov 2020 21:09:06 +0100

mupdf (1.17.0+ds1-1) unstable; urgency=medium

  [ Bastian Germann ]
  * Use system mujs (Closes: #949636)
  * Patch: Prevent thirdparty archive build
  * Exclude all thirdparty files
  * Remove thirdparty files
  * Build-Depend on python3 (Closes: #937093)
  * d/copyright: Prepare for 1.17
  * Refresh patches for 1.17.0

  [ Kan-Ru Chen ]
  * New upstream version 1.17.0+ds1
  * Bump standards-version to 4.5.0
  * Refresh patches

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Thu, 06 Aug 2020 21:48:09 +0900
