=== debian/control ===
--- 
+++ 
@@ -1,26 +1,14 @@
 Source: mupdf
 Section: text
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
+Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Uploaders: Quoc-Viet Nguyen <afelion@gmail.com>
-Build-Depends: debhelper (>= 12~),
-               dh-exec,
-               dpkg-dev (>= 1.16.1.1~),
-               freeglut3-dev,
-               libfreetype6-dev,
-               libharfbuzz-dev,
-               libjbig2dec-dev,
-               libjpeg-dev,
-               liblcms2-dev,
-               libopenjp2-7-dev,
-               libx11-dev,
-               libxext-dev,
-               pkg-config,
-               python:any,
-               zlib1g-dev
+Build-Depends: debhelper (>= 12), dh-exec, dpkg-dev (>= 1.16.1.1~),
+ libfreetype6-dev, pkg-config, libjpeg-dev, libjbig2dec-dev,
+ libmujs-dev, libopenjp2-7-dev, libx11-dev, libxext-dev, zlib1g-dev,
+ libharfbuzz-dev, freeglut3-dev, liblcms2-dev, python3:any
 Build-Conflicts: libssl-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: http://mupdf.com/
 Vcs-Git: https://salsa.debian.org/koster/mupdf.git
 Vcs-Browser: https://salsa.debian.org/koster/mupdf
@@ -37,7 +25,7 @@
 
 Package: mupdf
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: mupdf-tools
 Provides: pdf-viewer
 Description: lightweight PDF viewer
@@ -51,7 +39,7 @@
 
 Package: mupdf-tools
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: command line tools for the MuPDF viewer
  MuPDF is a lightweight PDF viewer and toolkit written in portable C.
  It also reads XPS, OpenXPS and ePub documents.
