=== debian/rules ===
--- 
+++ 
@@ -26,6 +26,7 @@
 
 BUILD_FLAGS = build=debian OS=Linux XCFLAGS="$(CFLAGS)" XLDFLAGS="$(LDFLAGS)" prefix=/usr
 # Force using system library
+BUILD_FLAGS += USE_SYSTEM_MUJS=yes
 BUILD_FLAGS += USE_SYSTEM_LIBS=yes
 # Force using system lcms2 (was not included in default system library set)
 BUILD_FLAGS += USE_SYSTEM_LCMS2=yes
@@ -63,8 +64,5 @@
 	-rm -rf generated
 	-rm -rf source/pdf/cmaps
 
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
-
 %:
 	dh $@
